'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.factory = factory;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ComponentResolverPlugin = function () {
  function ComponentResolverPlugin(source, target, _ref) {
    var include = _ref.include;

    _classCallCheck(this, ComponentResolverPlugin);

    this.source = source;
    this.target = target;
    this.include = include;
  }

  _createClass(ComponentResolverPlugin, [{
    key: 'apply',
    value: function apply(resolver) {
      var _this = this;

      var target = this.target;
      resolver.plugin(this.source, function (request, callback) {
        if (_this.include && !request.path.startsWith(_this.include)) {
          callback();
          return;
        }
        var rfs = resolver.fileSystem;
        var filename = _path2.default.basename(request.path) + '.js';
        var filePath = resolver.join(request.path, filename);
        rfs.stat(filePath, function (err, stats) {
          if (err || !stats.isFile()) {
            callback();
            return;
          }
          var indexPath = resolver.join(request.path, 'index.js');
          rfs.stat(indexPath, function (indexErr, indexStats) {
            if (!indexErr && indexStats.isFile()) {
              callback();
              return;
            }
            var relativePath = request.relativePath && resolver.join(request.relativePath, filename);
            var nextRequest = Object.assign({}, request, { path: filePath, relativePath: relativePath });
            resolver.doResolve(target, nextRequest, 'using path: ' + filePath, callback);
          });
        });
      });
    }
  }]);

  return ComponentResolverPlugin;
}();

exports.default = ComponentResolverPlugin;
function factory() {
  var opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  return new ComponentResolverPlugin('existing-directory', 'undescribed-raw-file', opts);
}
//# sourceMappingURL=index.js.map